<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

// Vérification du token CSRF
if ( !isset($_REQUEST['csrf-token']) || isset($_SESSION['csrf-token']) && ( $_REQUEST['csrf-token'] != $_SESSION['csrf-token'] ) )
  exit('{"etat":"nok","message":"Accès non autorisé"}');

// Récupération de l'action
if ( !isset($_REQUEST['action']) || !in_array($action = $_REQUEST['action'],array('prefs','docs','compteglobal')) )
  exit('{"etat":"nok","message":"Mauvais paramètrage"}');

///////////////////////////////////////////////
// Récupération des répertoires et documents //
///////////////////////////////////////////////
if ( ( $autorisation == 5 ) && ( $action == 'docs' ) )  {

  $mysqli = connectsql(false);
  $mats = '<option value="-1">[Choisissez une matière]</option>';
  $reps = array( -1 =>'<option value="-1">[Choisissez une matière]</option>');
  $docs = array( -1 => '<option value="0">[Choisissez une matière]</option>', 0 => '<option value="0">[Choisissez un répertoire]</option>' );
  // Récupération des répertoires, avec le chemin complet
  $resultat = $mysqli->query("SELECT r.id, r.nom, r.matiere,
                              CONCAT( ( SELECT GROUP_CONCAT(reps.nom SEPARATOR '/') FROM reps WHERE FIND_IN_SET(reps.id,r.parents) ) ,'/') AS parents
                              FROM reps AS r LEFT JOIN matieres AS m ON m.id = r.matiere
                              WHERE FIND_IN_SET(r.matiere,'${_SESSION['matieres']}') ORDER BY m.ordre, CONCAT(parents, r.nom)");
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )  {
      if ( !isset($reps[$r['matiere']]) )  {
        $reps[$r['matiere']] = '<option value="0">[Choisissez un répertoire]</option>';
        $mats .= "<option value=\"${r['matiere']}\">".( ( strpos($r['parents'],'/') ) ? strstr($r['parents'],'/',true) : $r['nom'] ).'</option>';
      }
      $reps[$r['matiere']] .= "<option value=\"${r['id']}\">${r['parents']}${r['nom']}</option>";
      // Récupération des documents
      $docs[$r['id']] = '<option value="0">[Choisissez un document]</option>';
      $res = $mysqli->query("SELECT id, nom, SUBSTRING(ext,2) AS ext FROM docs WHERE parent = ${r['id']} AND protection < 32");
      while ( $d = $res->fetch_assoc() )  {
        $docs[$r['id']] .= "<option value=\"${d['id']}\">${d['nom']} (${d['ext']})</option>";
      }
      $res->free();
    }
    $resultat->free();
  }
  exit(json_encode(array('recupok'=>1,'mats'=>$mats,'reps'=>$reps,'docs'=>$docs)));

}

///////////////////////////////////////////////
// Récupération des données d'un utilisateur //
///////////////////////////////////////////////
elseif ( ( $autorisation == 5 ) && ( $action == 'prefs' ) && connexionlight() )  {

  // Vérification que l'identifiant est valide
  $mysqli = connectsql(false);
  if ( isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
    $resultat = $mysqli->query("SELECT nom, prenom, login, matieres, mail as mail1, (LENGTH(mdp)=40) AS valide, (LEFT(mdp,1)='*') AS demande, (LENGTH(mdp)=1) AS invitation, autorisation, mailexp, mailcopie FROM utilisateurs WHERE id = $id");
    if ( $resultat->num_rows )  {
      $r = $resultat->fetch_assoc();
      $resultat->free();
      // Problème d'encodage des entiers, renvoyés en tant que chaîne.
      // Semble dépendre du driver MySQL, ne prenons pas de risque
      $r['valide'] = intval($r['valide']);
      $r['demande'] = intval($r['demande']);
      $r['invitation'] = intval($r['invitation']);
      $r['autorisation'] = intval($r['autorisation']);
      $r['mailcopie'] = intval($r['mailcopie']);
      // Récupération des autorisations d'envoi
      $resultat = $mysqli->query('SELECT val FROM prefs WHERE nom = "autorisation_mails"');
      $r['mailenvoi'] = ( $r['autorisation'] > 1 ) ? intval(( $resultat->fetch_row()[0] >> 4*($r['autorisation']-2) & 15 ) > 0) : 0;
      $resultat->free();
      $r['mail2'] = '';
      $r['etat'] = 'recupok';
      exit(json_encode($r));
    }
  }
  exit('{"etat":"nok","message":"Identifiant non valide"}');

}

///////////////////////////////////////////////
// Récupération des données d'un utilisateur //
///////////////////////////////////////////////
elseif ( ( $autorisation > 1 ) && ( $action == 'compteglobal' ) && $interfaceglobale )  {

  // $_SESSION['compteglobal'] contient l'identifiant du compte à utiliser
  // La deuxième partie de la requête sert de vérification : 
  //  * compte contenant une connexion vers cet utilisateur de ce Cahier
  //  * compte contenant au moins une autre connexion 
  $mysqli = connectsql(false,$interfaceglobale);
  $resultat = $mysqli->query("SELECT connexions FROM comptes 
                              WHERE id = ${_SESSION['compteglobal']} 
                                AND FIND_IN_SET((SELECT id FROM cahiers WHERE rep = TRIM(BOTH '/' FROM '${GLOBALS['chemin']}'))*1000+${_SESSION['id']}, connexions)
                                AND LOCATE(',',connexions)");
  if ( $resultat->num_rows )  {
    $cahiers = implode(',', array_filter(array_map( function($v){return ($v>0)?intdiv($v,1000):false;}, explode(',',$resultat->fetch_row()[0]) )) );
    $resultat->free();
    $resultat = $mysqli->query("SELECT rep, CONCAT(classe,' - ',nom,' (',ville,') ') AS classe
                                FROM cahiers LEFT JOIN lycees ON lycee = lycees.id
                                WHERE FIND_IN_SET(cahiers.id,'$cahiers') ORDER BY FIND_IN_SET(cahiers.id,'$cahiers')");
    $reps = array();
    while ( $r = $resultat->fetch_assoc() ) 
      if ( "/${r['rep']}/" != $chemin )
        $reps[$r['rep']] = $r['classe'];
    $resultat->free();
    $mysqli->close();
    exit(json_encode(array('etat'=>'recupok','cahiers'=>$reps)));
  }
  exit('{"etat":"nok","message":"Identifiant non valide"}');
}

// Réponse par défaut
exit( strlen($message) ? $message : '{"etat":"nok","message":"Accès interdit"}' );
?>
